<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layoutadmin}">
<link rel="stylesheet" th:href="@{/style.css}">
<head>
    <meta charset="UTF-8">
    <title>Schedule</title>
</head>
<body>
<div layout:fragment="main">
    <div class="header bg-gradient-primary pb-8 pt-5 pt-md-8">
        <div class="container-fluid">
            <div class="header-body">
                <!-- Card stats -->
                <div class="row">
                    <div class="col-xl-12 col-lg-12">
                        <div class="card card-stats mb-4 mb-xl-0">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col">
                                        <h5 class="card-title text-uppercase text-muted mb-0">List</h5>
                                        <span class="h2 font-weight-bold mb-0">Schedule</span>
                                    </div>
                                    <div class="col-auto">
                                        <div class="icon icon-shape bg-gradient-blue text-white rounded-circle shadow">
                                            <i class="fas fa-list"></i>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
    <div class="container-fluid mt--7">
        <!-- Table -->
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                                <h3 class="mb-0">Data List</h3>
                            </div>
                            <div class="col text-right">

                            </div>
                        </div>
                    </div>
                        <div class="card-body">
                            <input type="hidden" id="tahun" th:value="${selectedTahun.id}">
                            <div class="table-responsive">
                                <table
                                        id="table-jadwal"
                                        data-search="true"
                                        data-show-refresh="true"
                                        data-flat="true"
                                        data-pagination="true"
                                        data-ajax="ajaxRequestJadwal"
                                        data-side-pagination="server">
                                </table>
                            </div>
                        </div>
                </div>
            </div>
        </div>
        <!-- Dark table -->


    </div>

</div>
</body>
</html>
<link href="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/filter-control/bootstrap-table-filter-control.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/auto-refresh/bootstrap-table-auto-refresh.min.js"></script>
<script>
    function ajaxRequestJadwal(params) {
        // th:attr="data-url=@{/akademik/getdata-ploting(tahunAkademik='11fadd8d-383f-47b5-83ef-b6d79a5a96cd', kelas='61142fd3-701e-45a5-824a-b414f30e02ce')}"
        var url = '/akademik/detail-ploting-jadwal?tahun=' + $('#tahun').val()
        $.get(url + '&' + $.param(params.data)).then(function (res) {
            params.success(res)
        })
    }

    var $tableJadwal = $('#table-jadwal')

    $(function() {
        $tableJadwal.bootstrapTable({
            columns: [{
                field: 'kelas',
                title : 'Kelas',
                align: 'center',
                valign: 'middle'
            }, {
                title: 'Matakuliah',
                field: 'matkul',
                align: 'center',
                valign: 'middle'
            }, {
                title: 'SKS',
                field: 'sks',
                align: 'center',
                valign: 'middle'
            },{
                title: 'Dosen',
                field: 'dosen',
                align: 'center',
                valign: 'middle'
            },{
                title: 'Hari',
                field: 'totsks',
                align: 'center',
                valign: 'middle',
                formatter: selectHari

            },{
                title: 'Ruangan',
                field: 'html',
                align: 'center',
                valign: 'middle',
                formatter: selectRuangan
            },{
                title: 'Sesi',
                field: 'html',
                align: 'center',
                valign: 'middle',
                formatter: selectSesi
            }]
        })
    })

    function selectHari(value, row, index) {
        return [
            '<input type="hidden" id=kelas-'+ row.jadwal +'  value="'+ row.idKelas +'"> ',
            '<input type="hidden" id=dosen-'+ row.jadwal +'  value="'+ row.idDos +'"> ',
            '<input type="hidden" id=sks-'+ row.jadwal +'  value="'+ row.sks +'"> ',
            '<select id=hari-'+ row.jadwal +' onclick="validateHari(this);"  class="form-control">',
            '<option value="-">Pilih Hari</option>',
            '<option value="0">Minggu</option>',
            '<option value="1">Senin</option>',
            '<option value="2">Selasa</option>',
            '<option value="3">Rabu</option>',
            '<option value="4">Kamis</option>',
            '<option value="5">Jumat</option>',
            '<option value="6">Sabtu</option>',
            '</select>'
        ].join('')

    }

    function selectRuangan(value, row, index) {
        return [
            '<select id=ruangan-'+ row.jadwal +' onchange="validateRuangan(this);" style="width: 100%;" disabled class="form-control">',
            // '<option value="-" selected>Pilih Ruangan</option>',
            '</select>'
        ].join('')

    }

    function selectSesi(value, row, index) {
        return [
            '<select id=sesi-'+ row.jadwal +' class="form-control sesi-"'+ row.jadwal +' onchange="validateSesi(this);" disabled style="width: 100%;">',
            '</select>'
        ].join('')

    }

    function validateHari(arg) {
        var id = arg.getAttribute('id');
        var idRuangan = 'ruangan-'+id.slice(5);
        var idSesi = 'sesi-'+id.slice(5);
        var value = arg.value;


        $('#'+idRuangan).select2();
        if (value == '-'){
            $('#'+idRuangan).prop('disabled', true);
            $('#'+idRuangan).empty();
            $('#'+idSesi).prop('disabled', true);
            $('#'+idSesi).empty();
        }else {
            $('#'+idRuangan).prop('disabled', false);
            var url = '/get-ruangan-list'
            var newOption = new Option('Pilih Ruangan', '-', true, true);
            $('#'+idRuangan).append(newOption).trigger('change');
            $.getJSON(url, function (data) {
                $.each(data, function (key, entry) {
                    var newOption = new Option(entry.namaRuangan, entry.id, true, true);
                    $('#'+idRuangan).append(newOption);
                })
                $('#'+idRuangan).val("-").trigger("change");
            })
        }

    }

    function validateRuangan(arg) {
        var id = arg.getAttribute('id');
        var idSesi = 'sesi-'+id.slice(8);
        var value = arg.value;

        $('#'+idSesi).select2();
        if (value == '-'){
            $('#'+idSesi).prop('disabled', true);
            $('#'+idSesi).empty();
        }else {
            $('#'+idSesi).prop('disabled', false);
            $('#'+idSesi).empty();
            var url = '/akademik/validasi-sesi/'+id.slice(8)+'?tahun='+$('#tahun').val()+'&hari='+$('#hari-'+id.slice(8)).val()+'&sks='+$('#sks-'+id.slice(8)).val()+'&ruangan='+$('#ruangan-'+id.slice(8)).val()+'&kelas='+$('#'+'kelas-'+id.slice(8)).val()+'&dosen='+$('#'+'dosen-'+id.slice(8)).val();
            var newOption = new Option('Pilih Sesi ' + '\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0\xa0', '-', true, true);
            $('#'+idSesi).append(newOption).trigger('change');
            $.getJSON(url, function (data) {
                $.each(data, function (key, entry) {
                    if (entry.bentrok == null){
                        $('#'+idSesi).append($('<option></option>').attr('value', entry.idSesi).text(entry.namaSesi + ' ( ' + entry.mulai + ' - ' +entry.selesai + ' )'));
                    }else {
                        $('#'+idSesi).append($('<option disabled title="'+ entry.bentrok + ' ( '+ entry.dosen + ' - ' + entry.matkul + ')' + '" ></option>').attr('value', entry.idSesi).text(entry.namaSesi + ' ( ' + entry.mulai + ' - ' +entry.selesai + ' )'));
                    }

                })
                $('#'+idSesi).val("-");
            })
        }
    }

    function validateSesi(arg) {
        id = arg.getAttribute('id');
        var idRuangan = 'ruangan-'+id.slice(5);
        var idHari = 'hari-'+id.slice(5);
        var value = arg.value;

        if (value == '-'){
            console.log("test")
        }else {

            var request = {};
            var token = $("input[name='_csrf']").val();

            request["id"] = id.slice(5);
            request["hari"] = $('#' + idHari).val();
            request["ruangan"] = $('#' + idRuangan).val();
            request["sesi"] = value;

            $.ajax({
                type: "POST",
                contentType: "application/json",
                headers: {"X-CSRF-TOKEN": token},
                url: "/ploting-update",
                data: JSON.stringify(request),
                dataType: 'json',
                cache: false,
                timeout: 600000,
                success: function (result) {

                    Swal.fire({
                        position: 'top-end',
                        icon: 'success',
                        title: 'Data Sudah Terjadwalkan ',
                        showConfirmButton: false,
                        timer: 2000
                    })
                    $tableJadwal.bootstrapTable('refresh')
                },
                error: function (result) {
                }
            });
        }
    }
</script>